routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\MarcaController;
use App\Http\Controllers\ModeloController;
use App\Http\Controllers\SessionController;
use App\Http\Controllers\RegisterController;
use App\Http\Controllers\VehiculoController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

// rutas de los CRUDS
Route::resource('modelos', ModeloController::class)->middleware('auth');
Route::resource('marcas', MarcaController::class)->middleware('auth');
Route::resource('vehiculos', VehiculoController::class)->middleware('auth');

// rutas de autenticación
Route::get('/register', [RegisterController::class, 'create'])->name('auth.register');
Route::post('/register', [RegisterController::class, 'store'])->name('auth.store');
Route::get('/login', [SessionController::class, 'create'])->name('auth.login');
Route::post('/home', [SessionController::class, 'entrar'])->name('auth.entrar');
Route::get('/logout', [SessionController::class, 'destroy'])->name('auth.destroy')->middleware('auth');

// ruta para filtrar modelos por la marca
Route::get('/brands/list/{brand}', [ModeloController::class, 'lista'])->name('brand.lista')->middleware('auth');

app/Models/Vehiculo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Vehiculo extends Model
{
    use HasFactory;

    protected $table = "vehiculos";

    protected $fillable = [
        'id_brand',
        'id_model',
        'year',
        'placa',
        'color',
    ];

    public function modelo() {
        return $this->belongsTo(Modelo::class, 'id_model');        
    }

    public function marca() {
        return $this->belongsTo(Marca::class, 'id_brand');        
    }
}

app/Http/Controllers/VehiculoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Marca;
use App\Models\Modelo;
use App\Models\Vehiculo;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class VehiculoController extends Controller
{

    // función para llamar la tabla con todos los registros
    public function index(){
        $vehiculos = Vehiculo::where('status', '=', 1)->with('modelo')->with('marca')->get();
        return view('vehiculos.index', compact('vehiculos'));
    }

    // función para llamar el formulario
    public function create(){
        $modelos = Modelo::where('status', '=', 1)->with('marca')->get();
        $marcas = Marca::where('status', '=', 1)->get();
        return view('vehiculos.create', compact('modelos', 'marcas'));
    }

    // función para guardar un registro nuevo
    public function store(Request $request){
        $request->validate([
            'id_model' => 'required',
            'id_brand' => 'required',
            'year' => 'required',
            'placa' => 'required|unique:vehiculos|max:15',
            'color' => 'required|max:30'
        ]);
        $vehiculos = new Vehiculo();
        $vehiculos->id_brand = $request->id_brand;
        $vehiculos->id_model = $request->id_model;
        $vehiculos->year = $request->year;
        $vehiculos->placa = $request->placa;
        $vehiculos->color = $request->color;
        $vehiculos->save();
        return response()->json(['success' => true]);
    }

    // función para llamar el formulario con información del registro a editar
    public function edit($id){
        $modelos = Modelo::where('status', '=', 1)->with('marca')->get();
        $marcas = Marca::where('status', '=', 1)->get();
        $vehiculos = Vehiculo::where('id','=', $id)->get()->first();
        return view('vehiculos.edit', compact('modelos', 'marcas', 'vehiculos'));
    }

    // función para modificar un registro
    public function update(Request $request, $id){
        $request->validate([
            'id_model' => 'required',
            'id_brand' => 'required',
            'year' => 'required',
            'placa' => 'required|unique:vehiculos,placa,'.$id.'|max:15',
            'color' => 'required|max:30'
        ]);
        $vehiculos = Vehiculo::where('id', '=', $id)->get()->first();
        $vehiculos->id_brand = $request->id_brand;
        $vehiculos->id_model = $request->id_model;
        $vehiculos->year = $request->year;
        $vehiculos->placa = $request->placa;
        $vehiculos->color = $request->color;
        $vehiculos->save();
        return response()->json(['success' => true]);
    }

    // función para eliminar logicamente un registro
    public function destroy($id){
        $vehiculos = Vehiculo::where('id', '=', $id)->get()->first();
        $vehiculos->status = '0';
        $vehiculos->save();
        return response()->json(['success' => true]);
    }
}

resources/views/vehiculos/create.blade.php
@extends('layouts.index')

@section('content')
    <div class="">
        <form action="" id="formVehiculo" method="post">
            @csrf   
            
            <div class="form-group mb-3 mt-5">
                <label for="">Marca:</label>
                <select class="form-control" name="id_brand" id="id_brand" required autofocus>
                    <option>Seleccione una marca</option>
                    @foreach ($marcas as $marca)
                        <option value="{{$marca->id}}">{{$marca->name}}</option>
                    @endforeach
                </select>
            </div>

            <div class="form-group mb-3">
                <label for="">Modelo:</label>
                <select class="form-control" name="id_model" id="id_model" required>
                    <option>Seleccione un modelo</option>
                    @foreach ($modelos as $model)
                        <option value="{{$model->id}}">{{$model->name}}</option>
                    @endforeach
                </select>
            </div>
            
            <div class="form-group mb-3">
                <div class="form-group mb-3">
                    <label for="">Año:</label>
                    <input type="number" name="year" id="year" class="form-control" placeholder="escribe una año" aria-describedby="helpId" required>
                </div>
                <div class="form-group mb-3">
                    <label for="">Placa:</label>
                    <input type="text" name="placa" id="placa" class="form-control" placeholder="escribe una placa" aria-describedby="helpId" required>
                </div>
            </div>

            <div class="form-group mb-3">
                <div class="form-group mb-3">
                    <label for="">Color:</label>
                    <input type="text" name="color" id="color" class="form-control" placeholder="escribe un color" aria-describedby="helpId" required>
                </div>
            </div>
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarVehiculo">Registrar</button>
                <a class="btn btn-warning" href="{{route('vehiculos.index')}}" id="btnRegistrarVehiculo">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@section('javascript')

    <!-- Petición ajax para guardar un registro en la base de datos -->
    <script>
        $('#btnRegistrarVehiculo').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let id_brand  = $('#id_brand').val();
            let id_model = $('#id_model').val();
            let year = $('#year').val();
            let plate = $('#placa').val();
            let placa = plate.toUpperCase();
            let color = $('#color').val();
            let _token = $('input[name=_token]').val();
            // Petición ajax
            $.ajax({
                type: "POST",
                url: "{{route('vehiculos.store')}}",
                data: {
                    id_brand: id_brand,
                    id_model: id_model,
                    year: year,
                    placa: placa,
                    color: color,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Registro exitoso', 'Nuevo registro');
                        window.location.href = '/vehiculos'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                        
                    }
                }
            });
        });
    </script>

    <script>
            /*Evento onChange en el select id_brand
            para que el select modelos muestre los modelos de vehiculos
            que le pertenecen a la marca*/
            $('#id_brand').on('change', function(e){
                var id = e.target.value;
                $.get('/brands/list/' + id,function(data) {
                    $('#id_model').empty();
                    $('#id_model').append('<option value="" disable="true" selected="true">Seleccione un modelo</option>');
                    $.each(data, function(fetch, regenciesObj){
                        console.log(data);
                        $('#id_model').append('<option value="'+ regenciesObj.id +'">'+ regenciesObj.name +'</option>');
                    });
                });
            });
    </script>
@endsection

resources/views/vehiculos/edit.blade.php
@extends('layouts.index')

@section('content')
    <div class="">
        <form action="" id="formVehiculo" method="post">
            @csrf   

            <div class="form-group mb-3 mt-5">
                <label for="">Marca:</label>
                <select class="form-control" name="id_brand" id="id_brand" autofocus required>
                    <option>Seleccione una marca</option>
                    @foreach ($marcas as $marca)
                        <option value="{{$marca->id}}" {{$vehiculos->id_brand == $marca->id ? 'selected' : ''}}>{{$marca->name}}</option>
                    @endforeach
                </select>
            </div>

            <div class="form-group mb-3">
                <label for="">Modelo:</label>
                <select class="form-control" name="id_model" id="id_model" required>
                    <option>Seleccione un modelo</option>
                    @foreach ($modelos as $model)
                        <option value="{{$model->id}}" {{$vehiculos->id_model == $model->id ? 'selected' : ''}}>{{$model->name}}</option>
                    @endforeach
                </select>
            </div>

            <div class="form-group mb-3">
                <div class="form-group mb-3">
                    <label for="">Año:</label>
                    <input type="number" name="year" id="year" class="form-control" placeholder="escribe una año" aria-describedby="helpId" value="{{$vehiculos->year}}" required>
                </div>
                <div class="form-group mb-3">
                    <label for="">Placa:</label>
                    <input type="text" name="placa" id="placa" class="form-control" placeholder="escribe una placa" aria-describedby="helpId" value="{{$vehiculos->placa}}" required>
                </div>
            </div>

            <div class="form-group mb-3">
                <div class="form-group mb-3">
                    <label for="">Color:</label>
                    <input type="text" name="color" id="color" class="form-control" placeholder="escribe un color" aria-describedby="helpId" value="{{$vehiculos->color}}" required>
                </div>
            </div>
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarVehiculo">Registrar</button>
                <a class="btn btn-warning" href="{{route('vehiculos.index')}}" id="btnRegistrarVehiculo">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@section('javascript')

    <!-- Petición ajax para modificar un registro en la base de datos -->
    <script>
        $('#btnRegistrarVehiculo').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let id_brand  = $('#id_brand').val();
            let id_model = $('#id_model').val();
            let year = $('#year').val();
            let plate = $('#placa').val();
            let placa = plate.toUpperCase();
            let color = $('#color').val();
            let _token = $('input[name=_token]').val();
            // Petición ajax
            $.ajax({
                type: "PUT",
                url: "{{route('vehiculos.update', $vehiculos->id)}}",
                data: {
                    id_brand: id_brand,
                    id_model: id_model,
                    year: year,
                    placa: placa,
                    color: color,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Modificación exitosa', 'Modificar registro');
                        window.location.href = '/vehiculos'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                    }
                }
            });
        });
    </script>
@endsection

resources/views/vehiculos/index.blade.php
@extends('layouts.index')

@section('content')

    <div class="container">
        <div class="row mb-5 mt-5">
            <div class="col-md-6" style="display:flex;">
                <h3 class="text-secondary">Vehiculos</h3>
                <a href="" class="btn btn-primary" style="margin-left: 30px;" id="btnNuevoVehiculo">Nuevo vehiculo</a>
            </div>
            <div class="col-md-6">
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <table class="table cell-border" id="table-generic">
            <thead class="thead-light">
                <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">MARCA</th>
                    <th class="text-center">MODELO</th>
                    <th class="text-center">AÑO</th>
                    <th class="text-center">PLACA</th>
                    <th class="text-center">COLOR</th>
                    <th class="text-center">FECHA INGRESO</th>
                    <th class="text-center">ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($vehiculos as $auto)
                    <tr id="rowId-{{$auto->id}}">
                        <td class="text-center">
                            {{$auto->id}}
                        </td>
                        <td class="text-center">
                            {{$auto->marca->name}}
                        </td>
                        <td class="text-center">
                            {{$auto->modelo->name}}
                        </td>
                        <td class="text-center">
                            {{$auto->year}}
                        </td>
                        <td class="text-center">
                            {{$auto->placa}}
                        </td>
                        <td class="text-center">
                            {{$auto->color}}
                        </td>
                        <td class="text-center">
                            {{$auto->created_at->format('d/m/Y')}}
                        </td>
                        <td class="text-center">
                            <div class="btn-group">
                                <a href="{{route('vehiculos.edit',$auto->id)}}" id="editBtn" class="btn btn-warning" title="Modificar">Editar</a>
                                <form action="{{route('vehiculos.destroy', $auto->id)}}" style="display: inline" method="post">
                                    @csrf
                                    @method('DELETE')
                                    <button id="btnDelete" valor="{{$auto->id}}" class="btn btn-danger" title="Eliminar"> Eliminar </button>
                                </form>
                            </div>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
    </div>

@endsection

@section('javascript')

    <!-- Petición ajax para llamar a la vista create -->
    <script>
        $('#btnNuevoVehiculo').on('click', function(e){
            // Petición ajax
            $.ajax({
                type: "GET",
                url: "{{route('vehiculos.create')}}",
                success: function() { 
                    window.location.href = '/vehiculos/create'
                },
                error: function(xhr, ajaxOptions, thrownerror) { }
            })
        });
    </script>

    <script>
        // Ajax para eliminar un registro
        $(document).on('click', '#btnDelete', function(e){
            if(confirm('Está seguro que quiere eliminar este registro?')){
                e.preventDefault();
                let id = $(this).attr('valor');
                let _token = $('input[name=_token]').val();
                $.ajax({
                    type: "DELETE",
                    url: `vehiculos/${id}`,
                    data: {
                        id: id,
                        _token: _token
                    },
                    success:function(response){
                        toastr.success('Registro Eliminado', 'Eliminar', 3000);
                        $('#rowId-'+id).remove();
                    },
                    error: function (err) {
                        if(err.status == 422){
                            $.each(err.responseJSON.errors, function (i,error) {
                                toastr.success('error en eliminacion', +error[0], 3000);
                            })
                        }
                    }
                });
            }
        });
    </script>
@endsection